// cfifo.cpp

#include <alloc.h>
#include <mem.h>
#include "cfifo.h"



CFifo::CFifo(int isize)
{
 size=isize;
 data=(unsigned char*)malloc(size);
 if (data==NULL) size=0;
 Reset();
}


CFifo::~CFifo()
{
 if (data!=NULL) free(data);
}

unsigned short  CFifo::Write(unsigned char *wdata,unsigned short wsize)
{
 if (bytes<size)
 {
  if (wsize>size-bytes) wsize=size-bytes;

  if (last+wsize<=size)
  {
	memmove(data+last,wdata,wsize);
  }
  else
  {
	memmove(data+last,wdata,size-last);
	memmove(data,wdata+size-last,wsize+last-size);
  }
  bytes+=wsize;
  last+=wsize;
  if (last>=size) last-=size;
 }
 else wsize=0;
 return wsize;
}

unsigned short  CFifo::Read(unsigned char *rdata,unsigned short rsize)
{
 if (bytes)
 {
  if (rsize>bytes) rsize=bytes;
  if (first+rsize<size)
  {
	memmove(rdata,data+first,rsize);
  }
  else
  {
	memmove(rdata,data+first,size-first);
	memmove(rdata+size-first,data,rsize+first-size);
  }
  bytes-=rsize;
  first+=rsize;
  if (first>=size) first-=size;
 }
 else rsize=0;
 return rsize;
}

